/***************************************************************************
 * IOExcel.java
 *
 * 4 novembre 2006, 20.49
 * Copyright  2006  Alberto Casagrande <alberto.casagrande@gmail.com>
 ***************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package Ladder.main;

import java.io.File;
import java.io.IOException;
import java.util.Vector;
import jxl.*; 
import jxl.read.biff.BiffException;
import jxl.read.biff.PasswordException;
import jxl.write.*;
import java.util.LinkedList;

/**
 *
 * @author  Alberto Casagrande <alberto.casagrande@gmail.com>
 */
public class IOExcel {
    
    public IOExcel(File file) {
        new_file=true;
        excel_file=file;
    }
    
     public Object [][] readsheet(int sheet_n) throws IOException, jxl.read.biff.BiffException {
        read_workbook= Workbook.getWorkbook(excel_file);
        Sheet sheet = read_workbook.getSheet(sheet_n);
          
        opened_sheet=sheet_n;
        
        int columns=sheet.getColumns();
        int rows=sheet.getRows();
          
        Object [][] table = new Object [rows][columns];
              
        for (int y=0; y<rows; y++) {
            for (int x=0; x<columns; x++) {
                table[y][x]=(sheet.getCell(x,y)).getContents();
            }
        }
        
        read_workbook.close();
        new_file=false;
        
        return table;
    }
     
    private void write_new_sheet(Object [][] table) 
                                       throws IOException, jxl.write.WriteException {
    
        write_new_sheet(table,0);
    }
    
    private void write_new_sheet(Object [][] table, int sheet_n) 
                                       throws IOException, jxl.write.WriteException {
        
            WritableWorkbook workbook = Workbook.createWorkbook(excel_file);
            String sheet_name = new String("Fingerprint Cover Solution");
            WritableSheet sheet = workbook.createSheet(sheet_name,sheet_n);
            
            Label label;
            for (int y = 0; y< table.length; y++) {
                for (int x = 0; x< table[y].length; x++) {
                    label= new Label(x,y, (String)table[y][x]);
                    sheet.addCell(label);
                }
            }
            
            workbook.write();
            workbook.close();
        
    }
    
    public void writesheet(Object [][] table, int sheet_n) 
                                      throws IOException, jxl.write.WriteException {
    
        write_new_sheet(table, sheet_n);
    }
    
    public void writesheet(Object[][] table) 
                                      throws IOException, jxl.write.WriteException {
        write_new_sheet(table, 0);
    }
    
    
    
    public void writeworkbook(Vector solutions) 
                                      throws IOException, jxl.write.WriteException {

        WritableWorkbook workbook = Workbook.createWorkbook(excel_file);
        
        for (int i=0; i< solutions.size(); i++) {
            SolutionSheet solution=(SolutionSheet)solutions.get(i);
            WritableSheet sheet = workbook.createSheet(solution.name(),i);

            Object[][] table=solution.table();
            Label label;
            for (int y = 0; y< table.length; y++) {
                for (int x = 0; x< table[y].length; x++) {
                    label= new Label(x,y, (String)table[y][x]);
                    sheet.addCell(label);
                }
            }
            
        }
        workbook.write();
        workbook.close();
    }
    
    private File excel_file;
    private Workbook read_workbook;
    private int opened_sheet;
    private boolean new_file;
}
