/***************************************************************************
 * AllelesLengths.java
 *
 * 2 novembre 2006, 16.19
 * Copyright  2006  Alberto Casagrande <alberto.casagrande@gmail.com>
 ***************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package Ladder.main;

import java.util.LinkedList;
import java.util.ListIterator;      

/**
 *
 * @author  Alberto Casagrande <alberto.casagrande@gmail.com>
 */
public class MicroSatLengths {
    
    public MicroSatLengths(String specie, int len1, int len2) 
                                                 throws java.io.IOException {

        initMicroSatLengths(len1,len2);
        AddMicroSat(specie);
    }
    
    /** Creates a new instance of AllelesLengths */
    public MicroSatLengths(int len1, int len2) {
        initMicroSatLengths(len1,len2);
    }
    
    private void initMicroSatLengths(int len1, int len2) {
        length1=len1;
        length2=len2;
        
        microsats=new LinkedList();
    }
    
    public boolean HasSameLengths(int len1, int len2) {
        return (((length1==len1) && (length2==len2))||
                ((length1==len2) && (length2==len1)));
    }
    
    public boolean HasSameLengths(MicroSatLengths al) {
        return (((length1==al.length1) && (length2==al.length2))||
                ((length1==al.length2) && (length2==al.length1)));
    }
    
    public void AddMicroSat(String specie) {
        microsats.addLast(specie);
    }
    
    public void AddMicroSat(String specie, int len1, int len2) 
                                              throws java.io.IOException {
        if (HasSameLengths(len1,len2)) {
           AddMicroSat(specie);
        } else {
            throw new java.io.IOException("The allele have not the same lengths.");
        }
    }
    
    public LinkedList getMicroSats() {
        return microsats;
    }
    
    public int FirstLength() {
        return length1;
    }
    
    public int SecondLength() {
        return length2;
    }
    
    public void print() {
        
        System.out.print("Edge=[ (" + length1 + "," + length2 + ") , Labels={" );
        
        for (int j=0; j<microsats.size(); j++) {
            if (j!=0) System.out.print(", ");
            System.out.print((String)microsats.get(j));
        }
        System.out.println(" } ]");
       
    }
    
    private LinkedList microsats;
    private int length1;
    private int length2;
}
