/***************************************************************************
 * LadderUI.java
 *
 * 1 novembre 2006, 14.01
 * Copyright  2006  Alberto Casagrande <alberto.casagrande@gmail.com>
 ***************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package Ladder.ui;

import java.awt.Component;
import java.awt.image.BufferedImage;
import java.io.File;
import java.util.Date;
import java.io.IOException;
import Ladder.main.*;
import javax.imageio.ImageIO;
import javax.swing.JOptionPane;
import jxl.*; 

/**
 *
 * @author  Alberto Casagrande <alberto.casagrande@gmail.com>
 */
public class LadderUI extends javax.swing.JFrame {
    
    public LadderUI() {
        initComponents();
        loadLogo();
        
        loaded_data=false;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        Compute = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        MainMenu = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        Open = new javax.swing.JMenuItem();
        Save = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        Exit = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Ladder Finder");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 103, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 47, Short.MAX_VALUE)
        );

        Compute.setText("Compute");
        Compute.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComputeActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(Compute)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(Compute)
                .addContainerGap(13, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 101, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 47, Short.MAX_VALUE)
        );

        jMenu1.setText("File");
        Open.setText("Open");
        Open.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OpenActionPerformed(evt);
            }
        });

        jMenu1.add(Open);

        Save.setText("Save");
        Save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveActionPerformed(evt);
            }
        });

        jMenu1.add(Save);

        jMenu1.add(jSeparator1);

        Exit.setText("Exit");
        Exit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExitActionPerformed(evt);
            }
        });

        jMenu1.add(Exit);

        MainMenu.add(jMenu1);

        jMenu2.setText("Help");
        jMenuItem1.setText("LadderFinder License");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });

        jMenu2.add(jMenuItem1);

        jMenuItem2.setText("About LadderFinder");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });

        jMenu2.add(jMenuItem2);

        MainMenu.add(jMenu2);

        setJMenuBar(MainMenu);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(19, 19, 19)
                .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(23, 23, 23)
                .add(jPanel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 176, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jPanel3, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jPanel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        JOptionPane.showMessageDialog((Component) frame, "LadderFinder version 0.1.0\n"+
                "Copyright (C) 2006-2007 Alberto Casagrande\n"+
                "Email casagrande@appliedgenomics.org\n\n"+
                "LadderFinder home page:\n"+
                "http://www.appliedgenomics.org/tools/LadderFinder/\n\n"+
                "This software is supported by Applied Genomics Intitute\n"+
                "http://www.appliedgenomics.org/\n\n");
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        JOptionPane.showMessageDialog((Component) frame, "LadderFinder version 0.1.0\n"+
                "Copyright (C) 2006-2007 Alberto Casagrande\n"+
                "Email casagrande@appliedgenomics.org\n\n"+
                "This program is free software; you can redistribute it and/or modify\n"+
                "it under the terms of the GNU General Public License as published by\n"+
                "the Free Software Foundation; either version 2 of the License, or\n"+
                "(at your option) any later version.\n\n"+
                "This program is distributed in the hope that it will be useful,\n"+
                "but WITHOUT ANY WARRANTY; without even the implied warranty of\n"+
                "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"+
                "GNU Library General Public License for more details.\n\n"+
                "You should have received a copy of the GNU General Public License\n"+
                "along with this program; if not, write to the Free Software\n"+
                "Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.\n\n");
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void ComputeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ComputeActionPerformed
        Compute();
    }//GEN-LAST:event_ComputeActionPerformed

    public void Compute() {
        if (!loaded_data) {
            OpenToCompute();
            return;
        }
        try {
            s_window.dispose();
        } catch (Exception e) {}
        try {
            s_window=new SolutionWindow(GetTable());
            s_window.setVisible(true);
        } catch (FormatError e) {
            jTable1.requestFocusInWindow();
            jTable1.changeSelection(e.Row(), e.Column(), true, true);
            JOptionPane.showMessageDialog((Component) frame, "The "+
                    (String)jTable1.getValueAt(0,e.Column())+" lengths of "+
                    (String)jTable1.getValueAt(e.Row(),0)+" (position "+
                    e.Row()+"-"+e.Column()+") are not in " +
                    "the format \"length1-length2\".");
        }
    }   
    
    private void ExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExitActionPerformed
        System.exit(0);
    }//GEN-LAST:event_ExitActionPerformed

    private void OpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OpenActionPerformed
        try {
           if (!open_sheet.isVisible()) {
              open_sheet= new OpenSheet(this);
              open_sheet.setVisible(true);
           }
       } catch (Exception e) {
           open_sheet= new OpenSheet(this);
           open_sheet.setVisible(true);
       }
    }//GEN-LAST:event_OpenActionPerformed

    private void OpenToCompute() {  
        try {
           if (!open_sheet.isVisible()) {
              open_sheet= new OpenSheet(this,true);
              open_sheet.setVisible(true);
           }
       } catch (Exception e) {
           open_sheet= new OpenSheet(this,true);
           open_sheet.setVisible(true);
       }
    }                                    
    
    private void SaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveActionPerformed
       try {
           if (!save_sheet.isVisible()) {
              save_sheet= new SaveSolutionSheets(GetTable());
              save_sheet.setVisible(true);
           }
       } catch (Exception e) {
           save_sheet= new SaveSolutionSheets(GetTable());
           save_sheet.setVisible(true);
       }
    }//GEN-LAST:event_SaveActionPerformed
    
    private void loadLogo() {
        try {
            java.awt.Image image = javax.imageio.ImageIO.read(new File("LadderFinder.png"));
            javax.swing.JLabel jlabel= new javax.swing.JLabel(new javax.swing.ImageIcon(image));
            jScrollPane1.setViewportView(jlabel);
            setIconImage(ImageIO.read(new File("LadderFinder_icon.png")));
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    public void ReadDataFile(File datafile) {
        try {
           input_excel=new IOExcel(datafile);
        
           table=input_excel.readsheet(0);
        
           int columns=table[0].length;
        
           String [] title = new String [columns];
          
           if (columns>0) {
             title[0]=new String();
           }
          
           for (int x=1; x<columns; x++) {
              title[x]=new Integer(x).toString();
           }
          
           jTable1= new javax.swing.JTable();
           jTable1.setModel(new javax.swing.table.DefaultTableModel(table,title));
           //jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
           jTable1.setEditingColumn(1);
           jTable1.setEditingRow(1);
           jTable1.setMinimumSize(new java.awt.Dimension(1200, 600));
           jScrollPane1.setViewportView(jTable1);
           
           loaded_data=true;
        } catch (Exception e) {
            System.out.println(e);
        }
    }
    
    public Object[][] GetTable() {
        int rows=jTable1.getRowCount();
        int columns=jTable1.getColumnCount();
              
        for (int y=0; y<rows; y++) {
            for (int x=0; x<columns; x++) {
                table[y][x]=jTable1.getValueAt(y,x);
            }
        }
        
        return table;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LadderUI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Compute;
    private javax.swing.JMenuItem Exit;
    private javax.swing.JMenuBar MainMenu;
    private javax.swing.JMenuItem Open;
    private javax.swing.JMenuItem Save;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    // End of variables declaration//GEN-END:variables
    //private java.lang.String DataFile;
    private IOExcel input_excel;
    private Ladder.ui.SolutionWindow s_window;
    private SaveSolutionSheets save_sheet;
    private OpenSheet open_sheet;
    private Object[][] table;
    private javax.swing.JTable jTable1;
    private boolean loaded_data;

    private Object frame;
}
