/***************************************************************************
 * SaveSolutionSheets.java
 *
 * 5 novembre 2006, 0.28
 * Copyright  2006  Alberto Casagrande <alberto.casagrande@gmail.com>
 ***************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package Ladder.ui;

import Ladder.main.FilterClass;
import Ladder.main.FilterExcelFile;
import java.awt.Component;
import java.io.File;
import java.util.Vector;
import Ladder.main.IOExcel;
import javax.swing.JOptionPane;

/**
 *
 * @author  Alberto Casagrande <alberto.casagrande@gmail.com>
 */
public class SaveSolutionSheets extends javax.swing.JFrame {
    
    public SaveSolutionSheets(Vector s) {
        solutions=s;
        single_sheet=false;
        initComponents();
        jFileChooser1.addChoosableFileFilter(new FilterExcelFile());
    }
    
    public SaveSolutionSheets(Object[][] t) {
        table=t;
        single_sheet=true;
        initComponents();
        jFileChooser1.addChoosableFileFilter(new FilterExcelFile());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jFileChooser1 = new javax.swing.JFileChooser();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jFileChooser1.setDialogType(javax.swing.JFileChooser.SAVE_DIALOG);
        jFileChooser1.setFileFilter(jFileChooser1.getFileFilter());
        jFileChooser1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jFileChooser1ActionPerformed(evt);
            }
        });

        jFileChooser1.getAccessibleContext().setAccessibleName("*.xls");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFileChooser1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFileChooser1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 326, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jFileChooser1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jFileChooser1ActionPerformed
      if (evt.getActionCommand()=="ApproveSelection") {
        File file=jFileChooser1.getSelectedFile();

        String ext=FilterClass.getExtension(file);

        if (ext==null) {
	   ext=new String("xls");
           file=new File(file.getAbsolutePath()+".xls");
        }

        if (!ext.equals("xls")) {
            JOptionPane.showMessageDialog((Component) frame,"The choosed "+
			"extension is not supported.");
            return;
        }
 
        IOExcel solution_excel=new IOExcel(file);
        
        try {
           if (single_sheet) {
               solution_excel.writesheet(table);
           } else {
               solution_excel.writeworkbook(solutions);
           }
        } catch (Exception e) {
            System.out.println(e);
        }
      }
      dispose();
    }//GEN-LAST:event_jFileChooser1ActionPerformed

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JFileChooser jFileChooser1;
    // End of variables declaration//GEN-END:variables
    private Vector solutions;
    private Object[][] table;
    private boolean single_sheet;

    private Component frame;
}
